<cftry>
	<cfsilent>
		<cfset debugTemplatePath = GetCurrentTemplatePath()>
		<cfset path2site = GetProfileString(ListDeleteAt(debugTemplatePath, ListLen(debugTemplatePath, "\"), "\") & "\cfWatcherD.ini", "paths", "path2site")>

		<cfset slowPageLogAfter = GetProfileString("#path2site#\cfWatcher.ini", "logs", "slowPageLogAfter")>
		<cfset maxLogFileSize = GetProfileString("#path2site#\cfWatcher.ini", "logs", "maxLogFileSize")>
		<cfset path2logs = GetProfileString("#path2site#\cfWatcher.ini", "paths", "path2logs")>

		<cfset debugSites = GetProfileString("#path2site#\cfWatcher.ini", "debug", "debugSites")>
		<cfif ListLen(debugSites, ",") gt 0 and not ListFindNoCase(debugSites, cgi.server_name, ",") and not ListFindNoCase(debugSites, cgi.server_name, ",")>
			<cfabort>
		</cfif>

		<cfset startDeb = GetTickCount()>
		<cfset cacheKey = "____Eduard Tabara`s CF Server Monitoring Tool.___">
		<cfset timerKey = "____Eduard Tabara`s CF Server Monitoring Tool Timer.___">
		<cfset trackedRequestsKey = "____Eduard Tabara`s CF Server Monitoring Tool Tracked Requests.___">
		<cfset version = "2">
		<cfscript>
		/**
		 * Sorts a two dimensional array by the specified column using quicksort.
		 * 
		 * @param arrayToSort 	 The array to sort. (Required)
		 * @param key 	 Position in the second dimension to sort by. (Required)
		 * @param down 	 Index in fist dimension indicating where to begin sorting. (Required)
		 * @param top 	 Position in first dimension indicating where to end sorting. (Required)
		 * @return Returns an array. 
		 * @author Matthew Wear (matt.b.wear@gmail.com) 
		 * @version 1, March 28, 2006 
		 */
		function quickSort2DCFWatcher(arrayToSort, key, down, top) {
			var i = down;
			var j = top;
			var p = JavaCast("int",((down + top)/2));
			var x = arrayToSort[p][key];
			var temp = 0;
			var length = 0;
			var y = 0;
			var z = 0;
			
			do {
				while(arrayToSort[i][key] LT x AND i LT p) i=i+1;
				while(arrayToSort[j][key] GT x AND j GT p) j=j-1;
				if(i LT j){
					if(j EQ p){
						length = ArrayLen(arrayToSort)+1;
						for(z=length;z GT p+1;z=z-1)
							for(y=1;y LTE ArrayLen(arrayToSort[i]);y=y+1)
								arrayToSort[z][y]=arrayToSort[z-1][y];
										
						for(y=1;y LTE ArrayLen(arrayToSort[i]);y=y+1){ 
							arrayToSort[j+1][y] = arrayToSort[i][y]; 				
							arrayToSort[i][y] = 0;
						}
						
						ArrayDeleteAt(arrayToSort,i);
						
						i=i-1;
						p=p-1;
					}
						
					else if(i EQ p){
						length = ArrayLen(arrayToSort)+1;
						for(z=length;z GT p;z=z-1)
							for(y=1;y LTE ArrayLen(arrayToSort[i]);y=y+1)
								arrayToSort[z][y]=arrayToSort[z-1][y];
						
						j = j + 1;
						i = i + 1;
						p = p + 1;
						
						for(y=1;y LTE ArrayLen(arrayToSort[i]);y=y+1){ 
							arrayToSort[i-1][y] = arrayToSort[j][y]; 				
							arrayToSort[j][y] = 0;
						}
						
						ArrayDeleteAt(arrayToSort,j);
					}
					
					else{
						for(y=1;y LTE ArrayLen(arrayToSort[i]);y=y+1){
							temp = arrayToSort[i][y];
							arrayToSort[i][y] = arrayToSort[j][y];
							arrayToSort[j][y] = temp;		
						}
					}					
				}
						
				if(i LT p) i=i+1;
				if(j GT p) j=j-1;		
						
			}while(i LT j);
			
			if(down LT j) arrayToSort = quickSort2DCFWatcher(arrayToSort, key, down, p-1);
			if(i LT top) arrayToSort = quickSort2DCFWatcher(arrayToSort, key, p+1, top);
		
			return arrayToSort;
		}
		</cfscript>
		
		<cffunction name="getByteArrayCFWatcher" access="private" returnType="any" output="no">
			<cfargument name="size" type="numeric" required="true" />
			<cfscript>
				var emptyByteArray = createObject("java", "java.io.ByteArrayOutputStream").init().toByteArray();
				var byteClass = emptyByteArray.getClass().getComponentType();
				var byteArray = createObject("java","java.lang.reflect.Array").newInstance(byteClass, arguments.size);
				return byteArray;
			</cfscript>
		</cffunction>
		
		<cffunction name="zipCFWatcher" access="public" returntype="binary" output="no" hint="compresses a string and returns a byte array">
			<cfargument name="inStr" type="string" required="yes" hint="an input string from user" />
			<cfscript>
				var inputString = createObject("java","java.lang.String").init(javaCast("string",arguments.inStr));
				var compresser = createObject("java","java.util.zip.Deflater").init(javaCast("int",9)); // best compression
				var bos = createObject("java","java.io.ByteArrayOutputStream").init(javaCast("int",inputString.length()));
				var input = inputString.getBytes("UTF-8");
				var buf = getByteArrayCFWatcher(1024);
				var count = 0;
				compresser.setInput(input);
				compresser.finish();
				while (not compresser.finished()) {
					count = compresser.deflate(buf);
			        bos.write(buf, 0, count);
				}
				compresser.end();
				bos.close();
				return bos.toByteArray();
			</cfscript>
		</cffunction>
		
		<cffunction name="GetShortDebugOutput" output="No" returntype="any">
			<cfargument name="id" default="0" required="Yes">
			<cfargument name="slowPageThreshold" default="0">
			<cfset var savedDebug = "">
			<cfset var getPrimaryInfo = server[cacheKey].primaryInfo[Val(id)]>
			<cfsavecontent variable="savedDebug">
				<cfoutput>
					<table width="90%" align="center" border="1" cellpadding="2" cellspacing="2" bgcolor="##ffffff">
						<tr bgcolor="##ececec">
							<th><strong>Execution Time</strong></th>
							<th><strong>Free Memory</strong></th>
							<th><strong>Total Memory</strong></th>
							<th><strong>Max Memory</strong></th>
							<th><strong>Free Allocated (%)</strong></th>
							<th><strong>Allocated (%)</strong></th>
							<th><strong>Templates / Queries / CFCs / Exceptions / Other Types</strong></th>
							<th>RunningReq / QueuedReq / TimedOutReq</th>
						</tr>
						<tr bgcolor="##ffffff">
							<td align="center"<cfif slowPageThreshold lte getPrimaryInfo[8]> style="color:red;font-weight:bold"</cfif>>#getPrimaryInfo[8]#</td>
							<td align="center">#getPrimaryInfo[2]#</td>
							<td align="center">#getPrimaryInfo[3]#</td>
							<td align="center">#getPrimaryInfo[4]#</td>
							<td align="center">#Round((getPrimaryInfo[2] / Max(1, getPrimaryInfo[3])) * 100)#%</td>
							<td align="center">#Round((getPrimaryInfo[3] / Max(1, getPrimaryInfo[4]) ) * 100)#%</td>
							<td align="center">#getPrimaryInfo[15]# / #getPrimaryInfo[16]# / #getPrimaryInfo[14]# / <cfif getPrimaryInfo[17] gt 0><span style="color: red">#getPrimaryInfo[17]#</span><cfelse>0</cfif> / #getPrimaryInfo[18]#</td>
							<td align="center">#getPrimaryInfo[9]# / #getPrimaryInfo[11]# / #getPrimaryInfo[10]#</td>
						</tr>
						<tr bgcolor="##f6f6f6">
							<td colspan="8">
								<table width="100%">
									<tr>
										<td><em><strong>#getPrimaryInfo[12]#</strong></em></td>
										<td><em><strong>#getPrimaryInfo[6]#</strong></em></td>
										<td><em><strong>#DateFormat(getPrimaryInfo[7], "mm-dd-yyyy")# #TimeFormat(getPrimaryInfo[7], "HH:mm:ss")#</strong></em></td>
										<td><em><strong>Debug Time: #getPrimaryInfo[24]#ms</strong></em></td>
									</tr>
									<tr>
										<td colspan="4"><em><strong>#getPrimaryInfo[5]#</strong></em></td>
									</tr>
								</table>
							</td>
						</tr>
					</table>
				</cfoutput>
			</cfsavecontent>
			<cfreturn savedDebug>
		</cffunction>
		
		<cffunction name="GetDebugOutput" output="Yes" returntype="any">
			<cfargument name="id" default="0" required="Yes">
			<cfargument name="slowPageThreshold" default="0">
			<cfset var savedDebug = "">
			<cfset var getAll = "">
			<cfset var getCFCs = "">
			<cfset var getExceptions = "">
			<cfset var getTemplates = "">
			<cfset var getQueries = "">
			<cfset var getOtherTypes = "">
			<cfset var piCFCs = "">
			<cfset var piExceptions = "">
			<cfset var piTemplates = "">
			<cfset var piQueries = "">
			<cfset var piOtherTypes = "">
			<cfset var sqlscr = "">
			<cfset var attr = "">
			<cfset var arLen = "">
			<cfset var col = "">
			<cfset var et = 0>
			<cfset var arLen2 = 0>
			<cfset var tip = 0>
			<cfset var i = 0>
			<cfset var j = 0>
			<cfset var debugData = server[cacheKey].primaryInfo[Val(id)]>
			<cfsilent>
				<cfif IsArray(debugData[19]) and ArrayLen(debugData[19])>
					<cfset piCFCs = debugData[19]>
					<cfset getCFCs = quickSort2DCFWatcher(piCFCs, 1, 1, ArrayLen(piCFCs))>
				</cfif>
				<cfif IsArray(debugData[22]) and ArrayLen(debugData[22])>
					<cfset piExceptions = debugData[22]>
					<cfset getExceptions = piExceptions>
				</cfif>
				<cfif IsArray(debugData[20]) and ArrayLen(debugData[20])>
					<cfset piTemplates = debugData[20]>
					<cfset getTemplates = quickSort2DCFWatcher(piTemplates, 3, 1, ArrayLen(piTemplates))>
				</cfif>
				<cfif IsArray(debugData[21]) and ArrayLen(debugData[21])>
					<cfset piQueries = debugData[21]>
					<cfset getQueries = quickSort2DCFWatcher(piQueries, 9, 1, ArrayLen(piQueries))>
				</cfif>
				<cfif IsArray(debugData[23]) and ArrayLen(debugData[23])>
					<cfset piOtherTypes = debugData[23]>
					<cfset getOtherTypes = piOtherTypes>
				</cfif>
				<cfoutput>
					<cfsavecontent variable="savedDebug">
						<cfif not IsSimpleValue(getTemplates)>
							<br>
							<table border="1" cellpadding="2" cellspacing="1" bgcolor="white">
								<tr>
									<th align="center" colspan="4"><strong>T E M P L A T E S</strong></th>
								</tr>
								<tr>
									<th align="center">Template[Line] (Parent)</th>
									<th align="center">Execution Time</th>
									<th align="center">Timestamp</th>
									<th align="center">Type</th>
								</tr>
								<cfloop index="tip" from="#ArrayLen(getTemplates)#" to="1" step="-1">
									<tr valign="top">
										<td>#getTemplates[tip][1]#[#getTemplates[tip][7]#]<cfif Len(getTemplates[tip][2])><br><em>(#getTemplates[tip][2]#)</em></cfif></td>
										<td<cfif slowPageThreshold lte getTemplates[tip][3]> style="color:red;font-weight:bold"</cfif>>#getTemplates[tip][3]#</td>
										<td>#DateFormat(getTemplates[tip][4], "mm/dd/yyyy")# #TimeFormat(getTemplates[tip][4], "hh:mm tt")#</td>
										<td>#getTemplates[tip][5]#</td>
									</tr>
								</cfloop>
							</table>
						</cfif>
						<cfif not IsSimpleValue(getCFCs)>
							<br>
							<table border="1" cellpadding="2" cellspacing="1" bgcolor="white">
								<tr>
									<th align="center" colspan="5"><strong>C F C S</strong></th>
								</tr>
								<tr>
									<th align="center">CFC</th>
									<th align="center">Method</th>
									<th align="center">Execution Time</th>
									<th align="center">Timestamp</th>
									<th align="center">Template[Line]</th>
								</tr>
								<cfloop index="tip" from="#ArrayLen(getCFCs)#" to="1" step="-1">
									<tr valign="top">
										<td>#getCFCs[tip][4]#</td>
										<td>#getCFCs[tip][5]#</td>
										<td<cfif slowPageThreshold lte getCFCs[tip][1]> style="color:red;font-weight:bold"</cfif>>#getCFCs[tip][1]#</td>
										<td>#DateFormat(getCFCs[tip][2], "mm/dd/yyyy")# #TimeFormat(getCFCs[tip][2], "hh:mm tt")#</td>
										<td>#getCFCs[tip][6]#[#getCFCs[tip][8]#]</td>
									</tr>
								</cfloop>
							</table>
						</cfif>
						<cfif not IsSimpleValue(getQueries)>
							<br>
							<table border="1" cellpadding="2" cellspacing="1" bgcolor="white">
								<tr>
									<th align="center" colspan="10"><strong>Q U E R I E S</strong></th>
								</tr>
								<tr>
									<th align="center">Template[Line]</th>
									<th align="center">Datasource</th>
									<th align="center">Query Name</th>
									<th align="center">Records</th>
									<th align="center">Execution Time</th>
									<th align="center">Timestamp</th>
									<th align="center">Attributes</th>
									<th align="center">Cached</th>
									<th align="center">Type</th>
								</tr>
								<cfloop index="tip" from="#ArrayLen(getQueries)#" to="1" step="-1">
									<tr valign="top">
										<td>#getQueries[tip][12]#[#getQueries[tip][13]#]</td>
										<td><cfif Len(getQueries[tip][1])>#getQueries[tip][1]#<cfelse><em>QoQ</em></cfif></td>
										<td>
											<cfif getQueries[tip][6] eq "SqlQuery">
												<cfset sqlscr = Replace(getQueries[tip][4], Chr(13)&Chr(10), Chr(10), "ALL")>
												<cfset sqlscr = Replace(sqlscr, Chr(13), Chr(10), "ALL")>
												<cfset sqlscr = Replace(sqlscr, Chr(9), "", "ALL")>
												<cfset sqlscr = Replace(sqlscr, Chr(10), "<br />", "ALL")>
												<cfset sqlscr = Replace(sqlscr, "'", "`", "all")>
												<cfset sqlscr = Replace(sqlscr, '"', '``', "all")>
												<cfset sqlscr = Replace(sqlscr, "<br /><br />", "<br />", "ALL")>
												<a href="##sqlcodeAnc" onclick="document.getElementById('sqlcode').style.display='';document.getElementById('sqlcode').innerHTML='#sqlscr#'">#getQueries[tip][2]#</a>
											<cfelse>
												#getQueries[tip][2]#
											</cfif>
										</td>
										<td>#getQueries[tip][8]#</td>
										<td<cfif slowPageThreshold lte getQueries[tip][9]> style="color:red;font-weight:bold"</cfif>>#getQueries[tip][9]#</td>
										<td>#DateFormat(getQueries[tip][3], "mm/dd/yyyy")# #TimeFormat(getQueries[tip][3], "hh:mm tt")#</td>
										<td>
											<cfset attr = getQueries[tip][7]>
											<cfset arLen = ArrayLen(attr)>
											<cfif arLen gt 0>
												<table style="background-color: ##cccccc;">
													<tr>
														<th>SQL Type</th>
														<th>Type</th>
														<th>Value</th>
													</tr>
													<cfloop index="i" from="1" to="#arLen#">
														<tr>
															<td><cfif StructKeyExists(attr[i], "sqltype")>#attr[i].sqltype#</cfif></td>
															<td><cfif StructKeyExists(attr[i], "type")>#attr[i].type#</cfif></td>
															<td><cfif StructKeyExists(attr[i], "value")>#attr[i].value#</cfif></td>
														</tr>
													</cfloop>
												</table>
											</cfif>
										</td>
										<td>#YesNoFormat(Val(getQueries[tip][11]))#</td>
										<td>#getQueries[tip][6]#</td>
									</tr>
								</cfloop>
							</table>
							<a name="sqlcodeAnc"></a><div id="sqlcode" style="display: none; background-color: ##ffffcc;"></div>
						</cfif>
						<cfif not IsSimpleValue(getExceptions)>
							<br>
							<table border="1" cellpadding="2" cellspacing="1" bgcolor="white">
								<tr>
									<th align="center" colspan="5">E X C E P T I O N S</th>
								</tr>
								<tr>
									<th align="center">Line</th>
									<th align="center">Message</th>
									<th align="center">Timestamp</th>
									<th align="center">Stack Trace</th>
									<th align="center">Template</th>
								</tr>
								<cfloop index="tip" from="#ArrayLen(getExceptions)#" to="1" step="-1">
									<tr valign="top">
										<td>#getExceptions[tip][1]#</td>
										<td>#getExceptions[tip][2]#</td>
										<td>#DateFormat(getExceptions[tip][4], "mm/dd/yyyy")# #TimeFormat(getExceptions[tip][4], "hh:mm tt")#</td>
										<td>#getExceptions[tip][3]["Detail"]#</td>
										<td style="background-color: ##cccccc;">
											<cfset attr = getExceptions[tip][3]["TagContext"]>
											<cfset arLen = ArrayLen(attr)>
											<cfif arLen gt 0>
												<table>
													<tr>
														<th>COLUMN</th>
														<th>LINE</th>
														<th>TEMPLATE</th>
														<th>TYPE</th>
													</tr>
													<cfloop index="i" from="1" to="#arLen#">
														<tr>
															<td>#attr[i].COLUMN#</td>
															<td>#attr[i].LINE#</td>
															<td>#attr[i].TEMPLATE#</td>
															<td>#attr[i].TYPE#</td>
														</tr>
													</cfloop>
												</table>
											</cfif>
										</td>
									</tr>
								</cfloop>
							</table>
						</cfif>
						<cfif not IsSimpleValue(getOtherTypes)>
							<br>
							<table border="1" cellpadding="2" cellspacing="1" bgcolor="white">
								<tr>
									<th align="center" colspan="7"><strong>O T H E R&nbsp;&nbsp;&nbsp;&nbsp;T Y P E S</strong></th>
								</tr>
								<tr>
									<th align="center">Type</th>
									<th align="center">Template</th>
									<th align="center">Line</th>
									<th align="center">URL</th>
									<th align="center">Execution Time</th>
									<th align="center">Timestamp</th>
									<th align="center">Other</th>
								</tr>
								<cfloop index="tip" from="#ArrayLen(getOtherTypes)#" to="1" step="-1">
									<tr valign="top">
										<td>#getOtherTypes[tip][1]#</td>
										<td>#getOtherTypes[tip][2]#</td>
										<td>#getOtherTypes[tip][3]#</td>
										<td>#getOtherTypes[tip][4]#</td>
										<cfset et = Val(getOtherTypes[tip][5])-Val(getOtherTypes[tip][6])>
										<td<cfif slowPageThreshold lte et> style="color:red;font-weight:bold"</cfif>>#Val(et)#</td>
										<td>#DateFormat(getOtherTypes[tip][7], "mm/dd/yyyy")# #TimeFormat(getOtherTypes[tip][7], "hh:mm tt")#</td>
										<td>
											<table>
												<cfloop index="col" from="8" to="16">
													<cfif IsSimpleValue(getOtherTypes[tip][col]) and Len(getOtherTypes[tip][col])>
														<tr>
															<td>#getOtherTypes[tip][col]#</td>
															<td>
																<cfif IsSimpleValue(getOtherTypes[tip][col])>
																	#getOtherTypes[tip][col]#
																<cfelse>
																	<!---
																	<cfdump var="#getOtherTypes[tip][col]#">
																	--->
																	<cfset attr = getOtherTypes[tip][col]>
																	<cfset arLen = ArrayLen(attr)>
																	<cfif arLen gt 0>
																		<cfif IsArray(arLen[1]) and ArrayLen(arLen[1]) gt 1>
																			<cfset arLen2 = ArrayLen(arLen[1])>
																			<table style="background-color: ##cccccc;">
																				<cfloop index="i" from="1" to="#arLen#">
																					<tr>
																						<cfloop index="j" from="1" to="#arLen2#">
																							<td>#attr[i][j]#</td>
																						</cfloop>
																					</tr>
																				</cfloop>
																			</table>
																		<cfelse>
																			<table style="background-color: ##cccccc;">
																				<tr>
																					<cfloop index="i" from="1" to="#arLen#">
																						<td>#attr[i]#</td>
																					</cfloop>
																				</tr>
																			</table>
																		</cfif>
																	</cfif>
																</cfif>
															</td>
														</tr>
													<cfelse>
														<cfif not IsSimpleValue(getOtherTypes[tip][col])>
															<tr>
																<td>#getOtherTypes[tip][col]#</td>
																<td>
																	<cfif IsSimpleValue(getOtherTypes[tip][col])>
																		#getOtherTypes[tip][col]#
																	<cfelse>
																		<!---
																		<cfdump var="#getOtherTypes[tip][col]#">
																		--->
																		<cfset attr = getOtherTypes[tip][col]>
																		<cfset arLen = ArrayLen(attr)>
																		<cfif arLen gt 0>
																			<cfif IsArray(arLen[1]) and ArrayLen(arLen[1]) gt 1>
																				<cfset arLen2 = ArrayLen(arLen[1])>
																				<table style="background-color: ##cccccc;">
																					<cfloop index="i" from="1" to="#arLen#">
																						<tr>
																							<cfloop index="j" from="1" to="#arLen2#">
																								<td>#attr[i][j]#</td>
																							</cfloop>
																						</tr>
																					</cfloop>
																				</table>
																			<cfelse>
																				<table style="background-color: ##cccccc;">
																					<tr>
																						<cfloop index="i" from="1" to="#arLen#">
																							<td>#attr[i]#</td>
																						</cfloop>
																					</tr>
																				</table>
																			</cfif>
																		</cfif>
																	</cfif>
																</td>
															</tr>
														</cfif>
													</cfif>
												</cfloop>
											</table>
										</td>
									</tr>
								</cfloop>
							</table>
						</cfif>
					</cfsavecontent>
				</cfoutput>
			</cfsilent>
			<cfreturn savedDebug>
		</cffunction>
	</cfsilent>

	<cffunction name="cfWatcherDebug" output="Yes" returntype="any">
		<cfset var cfcsNumb = "">
		<cfset var templatesNumb = "">
		<cfset var queriesNumb = "">
		<cfset var exceptionsNumb = "">
		<cfset var otherTypesNumb = "">
		<cfset var factory = "">
		<cfset var cfDebugger = "">
		<cfset var qEvents = "">
		<cfset var currentApp = "">
		<cfset var needInit = "">
		<cfset var forceRefresh = "">
		<cfset var lastID = "">
		<cfset var perfMon = "">
		<cfset var current = "">
		<cfset var protocol = "">
		<cfset var port = "">
		<cfset var qryStr = "">
		<cfset var siteDomain = "">
		<cfset var fileLogDebug = "">
		<cfset var fileLogException = "">
		<cfset var cfc = "">
		<cfset var template_copy = "">
		<cfset var method = "">
		<cfset var realtemplate = "">
		<cfset var sql = "">
		<cfset var sql2 = "">
		<cfset var newattributes = "">
		<cfset var rezQ = "">
		<cfset var resultRC = "">
		<cfset var attr = "">
		<cfset var newsql = "">
		<cfset var historySize = "">
		<cfset var maxLengthInMemory = "">
		<cfset var id2Delete = "">
		<cfset var slowPageThreshold = "">
		<cfset var logOrder = "">
		<cfset var shortDebugString = "">
		<cfset var fullDebugString = "">
		<cfset var debug = "">
		<cfset var debugType = "">
		<cfset var debugIPs = "">
		<cfset var debugData = "">
		<cfset var x = "">
		<cfset var col = "">
		<cfset var orderLogFiles = "">
		<cfset var getLogFilesList = "">
		<cfsilent>
			<cfset cfcsNumb = 0>
			<cfset templatesNumb = 0>
			<cfset queriesNumb = 0>
			<cfset exceptionsNumb = 0>
			<cfset otherTypesNumb = 0>
			
			<cftry>
				<cfset factory = CreateObject("java", "coldfusion.server.ServiceFactory")>
				<cfset cfDebugger = factory.GetDebuggingService()>
				<cfset qEvents = cfDebugger.GetDebugger().GetData()>
				<cfcatch type="any">
					<cfset qEvents = QueryNew("")>
				</cfcatch>
			</cftry>
			<cfif not qEvents.RecordCount>
				<cfexit>
			</cfif>

			<cflock scope="server" type="exclusive" timeout="30">
				<cfif IsDefined("application")>
					<cfset currentApp = application.applicationName>
				<cfelse>
					<cfset currentApp = "">
				</cfif>
				
				<cfset needInit = false>
				<cfif not structKeyExists(server, cacheKey)>
					<cfset needInit = true>
				</cfif>
				<cfif not structKeyExists(server, timerKey)>
					<cfset server[timerKey] = Now()>
				</cfif>
				<cfif not structKeyExists(server, trackedRequestsKey)>
					<cfset server[trackedRequestsKey] = 0>
				</cfif>
				<cfset server[trackedRequestsKey] = server[trackedRequestsKey] + 1>
				
				<cfset forceRefresh = false>
				<cfif needInit or forceRefresh>
					<cfif not structKeyExists(server,cacheKey) or forceRefresh>
						<cfset server[cacheKey] = structNew()>
						<cfset server[cacheKey].primaryInfo = StructNew()>
						<cfset server[cacheKey].lastID = 1>
						<cfset lastID = 1>
					<cfelse>
						<cfset lastID = server[cacheKey].lastID + 1>
						<cfset server[cacheKey].lastID = server[cacheKey].lastID + 1>
					</cfif>
				<cfelse>
					<cfset lastID = server[cacheKey].lastID + 1>
					<cfset server[cacheKey].lastID = server[cacheKey].lastID + 1>
				</cfif>
				<cfset server[cacheKey].primaryInfo[lastID] = ArrayNew(1)>
				<cfset server[cacheKey].primaryInfo[lastID][1] = 1> <!--- "inUse" --->
	
				<cfscript>
					runtime = CreateObject("java","java.lang.Runtime").getRuntime();
					freeMemory = Round(runtime.freeMemory() / 1024 / 1024);
					totalMemory = Round(runtime.totalMemory() / 1024 / 1024);
					maxMemory = Round(runtime.maxMemory() / 1024 / 1024);
				</cfscript>
				<cfset perfMon = GetMetricData('PERF_MONITOR')>
			</cflock>
			<cfset current = structNew()>
			<cfset current.otherTypes = ArrayNew(2)>
			<cfset current.exceptions = ArrayNew(2)>
			<cfset current.cfcs = ArrayNew(2)>
			<cfset current.templates = ArrayNew(2)>
			<cfset current.queries = ArrayNew(2)>
			<cfloop query="qEvents">
				<cfswitch expression="#type#">
					<cfcase value="ExecutionTime">
						<cfif IsDefined("cgi.https") and cgi.https eq "on">
							<cfset protocol = "https://">
						<cfelse>
							<cfset protocol = "http://">
						</cfif>
						<cfif ListFind("443,80", cgi.SERVER_PORT, ",") eq 0>
							<cfset port = ":" & cgi.SERVER_PORT>
						<cfelse>
							<cfset port = "">
						</cfif>
						<cfif Len(cgi.query_string)>
							<cfset qryStr = "#protocol##cgi.SERVER_NAME##port##cgi.script_name#?#cgi.query_string#">
							<cfset siteDomain = "#protocol##cgi.SERVER_NAME##port#">
						<cfelse>
							<cfset qryStr = "#protocol##cgi.SERVER_NAME##port##cgi.script_name#">
							<cfset siteDomain = "#protocol##cgi.SERVER_NAME##port#">
						</cfif>
			
						<cfset server[cacheKey].primaryInfo[lastID][2] = freeMemory> <!--- "freeMemory" --->
						<cfset server[cacheKey].primaryInfo[lastID][3] = totalMemory> <!--- "totalMemory" --->
						<cfset server[cacheKey].primaryInfo[lastID][4] = maxMemory> <!--- "maxMemory" --->
						<cfset server[cacheKey].primaryInfo[lastID][5] = qryStr> <!--- "url" --->
						<cfset server[cacheKey].primaryInfo[lastID][6] = cgi.remote_addr> <!--- "ip" --->
						<cfset server[cacheKey].primaryInfo[lastID][7] = '#DateFormat(timestamp, "mm-dd-yyyy")# #TimeFormat(timestamp, "HH:mm:ss")#'> <!--- "timestamp" --->
						<cfset server[cacheKey].primaryInfo[lastID][8] = endTime - startTime> <!--- "et" --->
						<cfset server[cacheKey].primaryInfo[lastID][9] = perfMon.ReqRunning> <!--- "ReqRunning" --->
						<cfset server[cacheKey].primaryInfo[lastID][10] = perfMon.ReqTimedOut> <!--- "ReqTimedOut" --->
						<cfset server[cacheKey].primaryInfo[lastID][11] = perfMon.ReqQueued> <!--- "ReqQueued" --->
						<cfset server[cacheKey].primaryInfo[lastID][12] = currentApp> <!--- "application" --->
						<cfset server[cacheKey].primaryInfo[lastID][13] = siteDomain> <!--- "siteDomain" --->
						<cfif (endTime - startTime) gte slowPageLogAfter>
							<cfset fileLogDebug = true>
						<cfelse>
							<cfset fileLogDebug = false>
						</cfif>
					</cfcase>
				
					<cfcase value="Exception">
						<cfset exceptionsNumb = exceptionsNumb + 1>
						
						<cfset current.exceptions[exceptionsNumb][1] = line> <!--- "line" --->
						<cfset current.exceptions[exceptionsNumb][2] = message> <!--- "message" --->
						<cfset current.exceptions[exceptionsNumb][3] = stackTrace> <!--- "stackTrace" --->
						<cfset current.exceptions[exceptionsNumb][4] = '#DateFormat(timestamp, "mm-dd-yyyy")# #TimeFormat(timestamp, "HH:mm:ss")#'> <!--- "timestamp" --->
						<cfset current.exceptions[exceptionsNumb][5] = "exception"> <!--- "type" --->
						<cfset current.exceptions[exceptionsNumb][6] = currentApp> <!--- "application" --->
						<cfset fileLogException = true>
					</cfcase>
				
					<cfcase value="Template">
						<cfif Left(template, 5) eq "CFC[ ">
							<cfset cfc = trim(listFirst(template,"|"))>
							<cfset cfc = replaceNoCase(cfc, "CFC[ ", "")>
							<cfset template_copy = replaceNoCase(template, "([complex value])", "(COMPLEX VALUE)")>
							<cfset method = trim(listLast(listFirst(template_copy, "]"),"|"))>
							<cfset realtemplate	= reReplace(template, "CFC\[(.*)?\] from ", "")>
							<cfset cfcsNumb = cfcsNumb + 1>
	
							<cfset current.cfcs[cfcsNumb][1] = endTime - startTime> <!--- "et" --->
							<cfset current.cfcs[cfcsNumb][2] = '#DateFormat(timestamp, "mm-dd-yyyy")# #TimeFormat(timestamp, "HH:mm:ss")#'> <!--- "timestamp" --->
							<cfset current.cfcs[cfcsNumb][3] = starttime> <!--- "starttime" --->
							<cfset current.cfcs[cfcsNumb][4] = cfc> <!--- "cfc" --->
							<cfset current.cfcs[cfcsNumb][5] = method> <!--- "method" --->
							<cfset current.cfcs[cfcsNumb][6] = realtemplate> <!--- "template" --->
							<cfset current.cfcs[cfcsNumb][7] = currentApp> <!--- "application" --->
							<cfset current.cfcs[cfcsNumb][8] = line>
						<cfelse>
							<cfif parent eq "" or Right(parent, 16) eq "\Application.cfc" or Right(parent, 16) eq "\Application.cfm">
								<cfif Left(template, 5) neq "CFC[ " and Left(template, 6) neq "CFIDE\">
									<cfset templatesNumb = templatesNumb + 1>
	
									<cfset current.templates[templatesNumb][1] = template> <!--- "template" --->
									<cfset current.templates[templatesNumb][2] = parent> <!--- "parent" --->
									<cfset current.templates[templatesNumb][3] = endTime - startTime> <!--- "et" --->
									<cfset current.templates[templatesNumb][4] = '#DateFormat(timestamp, "mm-dd-yyyy")# #TimeFormat(timestamp, "HH:mm:ss")#'> <!--- "timestamp" --->
									<cfset current.templates[templatesNumb][5] = "template"> <!--- "type" --->
									<cfset current.templates[templatesNumb][6] = currentApp> <!--- "application" --->
									<cfset current.templates[templatesNumb][7] = line>
								</cfif>
							<cfelse>
								<cfif parent neq "" and Right(parent, 16) neq "\Application.cfc" and Right(parent, 16) neq "\Application.cfm">
									<cfif Left(template, 5) neq "CFC[ " and Left(template, 6) neq "CFIDE\">
										<cfset templatesNumb = templatesNumb + 1>
	
										<cfset current.templates[templatesNumb][1] = template> <!--- "template" --->
										<cfset current.templates[templatesNumb][2] = parent> <!--- "parent" --->
										<cfset current.templates[templatesNumb][3] = endTime - startTime> <!--- "et" --->
										<cfset current.templates[templatesNumb][4] = '#DateFormat(timestamp, "mm-dd-yyyy")# #TimeFormat(timestamp, "HH:mm:ss")#'> <!--- "timestamp" --->
										<cfset current.templates[templatesNumb][5] = "template"> <!--- "type" --->
										<cfset current.templates[templatesNumb][6] = currentApp> <!--- "application" --->
										<cfset current.templates[templatesNumb][7] = line>
									</cfif>
								</cfif>
							</cfif>
						</cfif>
					</cfcase>
					
					<cfcase value="StoredProcedure,SqlQuery" delimiters=",">
						<cfset sql = body>
						<cfset sql2 = Replace(Replace(body, Chr(10), "", "All"), Chr(13), "", "All")>
						<cfif isArray(attributes)>
							<cfset newattributes = attributes>
						<cfelse>
							<cfset newattributes = "">
						</cfif>
						<cfif isQuery(result) and datasource neq "">
							<cfset rezQ = result>
							<cfset resultRC = rezQ.RecordCount>
						<cfelse>
							<cfset resultRC = 0>
						</cfif>
						<cfif datasource neq "">
							<cfif type is "StoredProcedure">
								<cfset sql = "Stored Procedure">
								<cfset sql2 = "">
							<cfelseif ArrayLen(newattributes) gt 0>
								<cfset attr = newattributes>
								<cfif isArray(attr) and arrayLen(attr)>
									<cfloop index="x" from="1" to="#arrayLen(attr)#">
										<cfset newsql = sql>
										<cfset newsql = replace(newsql, "?", attr[1].value)>
										<cfset newsql = reReplace(newsql, "[\n\r]{2,}", "", "all")>
										<cfset newsql = reReplace(newsql, "[[:space:]]{2,}", " ", "all")>
										<cfset sql = newsql>
									</cfloop>
									<cfset sql2 = Replace(Replace(sql, Chr(10), "", "All"), Chr(13), "", "All")>
								</cfif>
							</cfif>
						</cfif>
						<cfset queriesNumb = queriesNumb + 1>
	
						<cfset current.queries[queriesNumb][1] = datasource> <!--- "datasource" --->
						<cfset current.queries[queriesNumb][2] = name> <!--- "queryname" --->
						<cfset current.queries[queriesNumb][3] = '#DateFormat(timestamp, "mm-dd-yyyy")# #TimeFormat(timestamp, "HH:mm:ss")#'> <!--- "timestamp" --->
						<cfset current.queries[queriesNumb][4] = sql> <!--- "sql" --->
						<cfset current.queries[queriesNumb][5] = sql2> <!--- "sql2" --->
						<cfset current.queries[queriesNumb][6] = type> <!--- "type" --->
						<cfset current.queries[queriesNumb][7] = newattributes> <!--- "newattributes" --->
						<cfset current.queries[queriesNumb][8] = resultRC> <!--- "recordsreturned" --->
						<cfset current.queries[queriesNumb][9] = endTime - startTime> <!--- "et" --->
						<cfset current.queries[queriesNumb][10] = currentApp> <!--- "application" --->
						<cfset current.queries[queriesNumb][11] = CACHEDQUERY> <!--- "CACHEDQUERY" --->
						<cfset current.queries[queriesNumb][12] = template> <!--- "TEMPLATE" --->
						<cfset current.queries[queriesNumb][13] = line>
					</cfcase>
					
					<cfdefaultcase>
						<cfif type neq "Exception" and type neq "ExecutionTime" and type neq "Template" and type neq "StoredProcedure" and type neq "SqlQuery" and type neq "Unexpected">
							<cfset otherTypesNumb = otherTypesNumb + 1>
							
							<cfset current.otherTypes[otherTypesNumb][1] = type>
							<cfset current.otherTypes[otherTypesNumb][2] = template>
							<cfset current.otherTypes[otherTypesNumb][3] = line>
							<cfset current.otherTypes[otherTypesNumb][4] = url>
							<cfset current.otherTypes[otherTypesNumb][5] = endtime>
							<cfset current.otherTypes[otherTypesNumb][6] = starttime>
							<cfset current.otherTypes[otherTypesNumb][7] = timeStamp>
							<cfset current.otherTypes[otherTypesNumb][8] = ATTRIBUTES>
							<cfset current.otherTypes[otherTypesNumb][9] = BODY>
							<cfset current.otherTypes[otherTypesNumb][10] = CATEGORY>
							<cfset current.otherTypes[otherTypesNumb][11] = DATASOURCE>
							<cfset current.otherTypes[otherTypesNumb][12] = MESSAGE>
							<cfset current.otherTypes[otherTypesNumb][13] = NAME>
							<cfset current.otherTypes[otherTypesNumb][14] = PARENT>
							<cfset current.otherTypes[otherTypesNumb][15] = PRIORITY>
							<cfset current.otherTypes[otherTypesNumb][16] = ROWCOUNT>
							<!---
							<cfloop index="col" list="type,template,line,url,endtime,starttime,timeStamp,ATTRIBUTES,BODY,CATEGORY,DATASOURCE,MESSAGE,NAME,PARENT,PRIORITY,ROWCOUNT">
								<cfif (IsSimpleValue(Evaluate(col)) and Len(Evaluate(col))) or not IsSimpleValue(Evaluate(col))>
									<cfset current.otherTypes[otherTypesNumb][col] = Evaluate(col)>
								</cfif>
							</cfloop>
							--->
							<cfset current.otherTypes[otherTypesNumb][17] = '#DateFormat(timestamp, "mm-dd-yyyy")# #TimeFormat(timestamp, "HH:mm:ss")#'> <!--- "timestamp" --->
							<cfset current.otherTypes[otherTypesNumb][18] = currentApp> <!--- "application" --->
						</cfif>
					</cfdefaultcase>
				</cfswitch>
			</cfloop>
			<cfset server[cacheKey].primaryInfo[lastID][14] = cfcsNumb> <!--- "cfcs" --->
			<cfset server[cacheKey].primaryInfo[lastID][15] = templatesNumb> <!--- "templates" --->
			<cfset server[cacheKey].primaryInfo[lastID][16] = queriesNumb> <!--- "queries" --->
			<cfset server[cacheKey].primaryInfo[lastID][17] = exceptionsNumb> <!--- "exceptions" --->
			<cfset server[cacheKey].primaryInfo[lastID][18] = otherTypesNumb> <!--- "otherTypes" --->
			<cfset server[cacheKey].primaryInfo[lastID][19] = current.cfcs> <!--- "qcfcs" --->
			<cfset server[cacheKey].primaryInfo[lastID][20] = current.templates> <!--- "qtemplates" --->
			<cfset server[cacheKey].primaryInfo[lastID][21] = current.queries> <!--- "qqueries" --->
			<cfset server[cacheKey].primaryInfo[lastID][22] = current.exceptions> <!--- "qexceptions" --->
			<cfset server[cacheKey].primaryInfo[lastID][23] = current.otherTypes> <!--- "qotherTypes" --->
	
			<cfset historySize = Val(GetProfileString("#path2site#\cfWatcher.ini", "display", "historySize"))>
			<cfset maxLengthInMemory = Val(GetProfileString("#path2site#\cfWatcher.ini", "display", "maxLengthInMemory"))>
			
			<cfset id2Delete = server[cacheKey].lastID - historySize>
			<cfloop condition="StructDelete(server[cacheKey].primaryInfo, id2Delete, 'True') eq 'Yes'">
				<cfset id2Delete = id2Delete - 1>
			</cfloop>
	
			<cfset server[cacheKey].primaryInfo[lastID][1] = 0> <!--- "inUse" --->
			<cfset server[cacheKey].primaryInfo[lastID][24] = GetTickCount()-startDeb> <!--- "run" --->
		</cfsilent>
		<cfif Len(Trim(path2site))>
			<cfsilent>
				<cfset slowPageThreshold = Val(GetProfileString("#path2site#\cfWatcher.ini", "display", "slowPageThreshold"))>
				<cfif fileLogDebug and (not IsDefined("fileLogException") or fileLogException eq false or fileLogException eq "")>
					<cflock timeout="3" name="saveLogFile">
						<cfdirectory action="LIST" name="getLogFilesList" directory="#path2logs#" filter="#currentApp#_SlowRequestsShort*.log">
						<cfquery name="orderLogFiles" dbtype="query">
							Select name, size, dateLastModified
							From getLogFilesList
							Order by name desc
						</cfquery>
						<cfif orderLogFiles.RecordCount>
							<cfset logOrder = Val(RemoveChars(ListGetAt(orderLogFiles.name[1], 1, "."), 1, 17))>
							<cfif orderLogFiles.size[1] gte maxLogFileSize>
								<cfset logOrder = logOrder + 1>
							</cfif>
						<cfelse>
							<cfset logOrder = 1>
						</cfif>
						<cfset shortDebugString = GetShortDebugOutput(lastID, slowPageThreshold)>
						<cfset fullDebugString = GetDebugOutput(lastID, slowPageThreshold)>
						<cfscript>
							oFileWriter = CreateObject("java", "java.io.FileWriter").init("#path2logs#/#currentApp#_SlowRequests#logOrder#.log", JavaCast("boolean","true"));
							oBufferedWriter = CreateObject("java", "java.io.BufferedWriter").init(oFileWriter); 
							oBufferedWriter.write("#ToBase64(zipCFWatcher(shortDebugString & Chr(13) & fullDebugString))##Chr(13)#");
							oBufferedWriter.flush();
							oBufferedWriter.close();
			
							oFileWriter = CreateObject("java", "java.io.FileWriter").init("#path2logs#/#currentApp#_SlowRequestsShort#logOrder#.log", JavaCast("boolean","true"));
							oBufferedWriter = CreateObject("java", "java.io.BufferedWriter").init(oFileWriter); 
							oBufferedWriter.write("#ToBase64(zipCFWatcher(shortDebugString))##Chr(13)#");
							oBufferedWriter.flush();
							oBufferedWriter.close();
						</cfscript>
					</cflock>
				</cfif>
				<cfif IsDefined("fileLogException") and fileLogException eq true>
					<cfdirectory action="LIST" name="getLogFilesList" directory="#path2logs#" filter="#currentApp#_ExeptionRequestsShort*.log">
					<cfquery name="orderLogFiles" dbtype="query">
						Select name, size, dateLastModified
						From getLogFilesList
						Order by name desc
					</cfquery>
					<cfif orderLogFiles.RecordCount>
						<cfset logOrder = Val(RemoveChars(ListGetAt(orderLogFiles.name[1], 1, "."), 1, 21))>
						<cfif orderLogFiles.size[1] gte maxLogFileSize>
							<cfset logOrder = logOrder + 1>
						</cfif>
					<cfelse>
						<cfset logOrder = 1>
					</cfif>
					<cfif not IsDefined("shortDebugString") or Len(shortDebugString) eq 0>
						<cfset shortDebugString = GetShortDebugOutput(lastID, slowPageThreshold)>
						<cfset fullDebugString = GetDebugOutput(lastID, slowPageThreshold)>
					</cfif>
					<cflock timeout="3" name="saveLogFile">
						<cfscript>
							oFileWriter = CreateObject("java", "java.io.FileWriter").init("#path2logs#/#currentApp#_ExeptionRequests#logOrder#.log", JavaCast("boolean","true"));
							oBufferedWriter = CreateObject("java", "java.io.BufferedWriter").init(oFileWriter); 
							oBufferedWriter.write("#ToBase64(zipCFWatcher(shortDebugString & Chr(13) & fullDebugString))##Chr(13)#");
							oBufferedWriter.flush();
							oBufferedWriter.close();
			
							oFileWriter = CreateObject("java", "java.io.FileWriter").init("#path2logs#/#currentApp#_ExeptionRequestsShort#logOrder#.log", JavaCast("boolean","true"));
							oBufferedWriter = CreateObject("java", "java.io.BufferedWriter").init(oFileWriter); 
							oBufferedWriter.write("#ToBase64(zipCFWatcher(shortDebugString))##Chr(13)#");
							oBufferedWriter.flush();
							oBufferedWriter.close();
						</cfscript>
					</cflock>
				</cfif>
			</cfsilent>
	
			<cfset debug = GetProfileString("#path2site#\cfWatcher.ini", "debug", "debug")>
			<cfif debug eq "On">
				<cfsilent>
					<cfset debugType = GetProfileString("#path2site#\cfWatcher.ini", "debug", "debugType")>
					<cfset debugIPs = GetProfileString("#path2site#\cfWatcher.ini", "debug", "debugIPs")>
					<cfset debugData = server[cacheKey]>
					<cfif not IsDefined("shortDebugString") or Len(shortDebugString) eq 0>
						<cfset shortDebugString = GetShortDebugOutput(lastID, slowPageThreshold)>
						<cfset fullDebugString = GetDebugOutput(lastID, slowPageThreshold)>
					</cfif>
				</cfsilent>
				<cfif ListLen(debugIPs, ",") gt 0>
					<cfif ListFindNoCase(debugIPs, cgi.remote_Addr, ",")>
						<hr>
						<h3>Debugging Information</h3>
						<cfoutput>#shortDebugString#</cfoutput>
						<cfif debugType eq "Full">
							<cfoutput>#fullDebugString#</cfoutput>
						</cfif>
					</cfif>
				<cfelse>
					<hr>
					<h3>Debugging Information</h3>
					<cfoutput>#shortDebugString#</cfoutput>
					<cfif debugType eq "Full">
						<cfoutput>#fullDebugString#</cfoutput>
					</cfif>
				</cfif>
			</cfif>
		</cfif>
	</cffunction>
	
	<cfset cfWatcherDebug()>
	
	<cfcatch type="Any">
		eroare mlia<br>
		<!---
		<cfdump var="#variables#" label="variables">
		--->
		<cfdump var="#CFCATCH#" label="CFCATCH">
	</cfcatch>
</cftry>
