<cfcomponent>
	<cfsilent>
	<cfscript>
		this.name = "cfWatcher";
		this.clientManagement = false;
		this.sessionManagement = true;
		this.setClientCookies = true;
		this.sessionTimeOut = CreateTimeSpan(0,0,30,0);
		this.applicationTimeOut = CreateTimeSpan(5,0,0,0);
	</cfscript>
	
	<cffunction name="onApplicationStart">
	</cffunction>
	
	<cffunction name="onApplicationEnd">
	</cffunction>

	<cffunction name="onRequestStart">
		<cfset var currentTemplatePath = GetCurrentTemplatePath()>
		<cfsilent>
			<cfset currentTemplatePath = ListDeleteAt(currentTemplatePath, ListLen(currentTemplatePath, "\"), "\")>
			<cfset currentTemplatePath = ListDeleteAt(currentTemplatePath, ListLen(currentTemplatePath, "\"), "\") & "\ini">
			<cfinclude template="_globalSettings.cfm">
			<cfset request.path2site = GetProfileString(currentTemplatePath & "\cfWatcher.ini", "paths", "path2site")>
			<cfif Len(Trim(request.path2site)) eq 0><cfset request.path2site = ExpandPath("\")></cfif>
		</cfsilent>
	</cffunction>

	<cffunction name="onSessionStart">
	</cffunction>
	
	<cffunction name="onSessionEnd">
	</cffunction>

	<cffunction name="IsFlushInitiated" access="public" returntype="boolean" output="false" hint="Determines if a CFFlush tag has been executed yet.">
		<cftry>
			<!--- Try set a status code. --->
			<cfheader statuscode="200" statustext="OK" />
			<!--- We set the status code, flush has not	been called. --->
			<cfreturn false />
			<cfcatch>
				<!--- The CFHeader tag has thrown an error. CFFlush	has already been executed.	--->
				<cfreturn true />
			</cfcatch>
		</cftry>
	</cffunction>

	<cffunction name="onRequest">
		<cfargument name="targetPage" type="String" required="true" />
		<cfset var local = structNew() />
		<cfif (not IsDefined("loadContent") or loadContent eq true) and GetPageContext().GetResponse().IsCommitted()>
			<cfsavecontent variable="local.content">
				<cfinclude template="#arguments.targetPage#">
			</cfsavecontent>
			<cfset local.content = Replace(local.content, "< /", "</", "all") />
			<cfset local.content = Replace(local.content, " />", "/>", "all") />
			<cfset local.content = Replace(local.content, "#Chr(09)#</", " </", "all") />
			<cfset local.content = Replace(local.content, Chr(09), "", "all") />
			<cfset local.content = Replace(local.content, "#Chr(13)##Chr(10)##Chr(13)##Chr(10)#", "#Chr(13)##Chr(10)#", "all") />
			<cfset local.content = Replace(local.content, ">#Chr(13)##Chr(10)#<", "><", "all") />
			<cfset local.content = Replace(local.content, ">#Chr(13)##Chr(10)# <", "><", "all") />
			<cfoutput>#local.content#</cfoutput>
		<cfelse>
			<cfinclude template="#targetPage#">
		</cfif>
	</cffunction>

	<cffunction name="onRequestEnd" returntype="boolean" output="true">
		<cfargument name="thePage" type="string" required="true">
		<cfset var fileOut = "">
		<cfset var out = "">
		<cfset var pageOut = getPageContext().getCFOutput().getString()>
		<cftry>
			<cfif (not IsDefined("loadContent") or loadContent eq false) and not IsFlushInitiated() and IsDefined("cgi.HTTP_ACCEPT_ENCODING") and FindNoCase("gzip", cgi.HTTP_ACCEPT_ENCODING, 1) gt 0 and FindNoCase("return _CF_checkfrm(this)", pageOut, 1) eq 0>
				<cfset pageOut = Replace(pageOut, "< /", "</", "all") />
				<cfset pageOut = Replace(pageOut, " />", "/>", "all") />
				<cfset pageOut = Replace(pageOut, "> ", ">", "all") />
				<cfset pageOut = Replace(pageOut, "#Chr(09)#</", " </", "all") />
				<cfset pageOut = Replace(pageOut, Chr(09), "", "all") />
				<cfset pageOut = Replace(pageOut, "#Chr(13)##Chr(10)##Chr(13)##Chr(10)#", "#Chr(13)##Chr(10)#", "all") />
				<cfset pageOut = Replace(pageOut, ">#Chr(13)##Chr(10)#<", "><", "all") />
				<cfset pageOut = Replace(pageOut, ">#Chr(13)##Chr(10)# <", "><", "all") />
				<cfset fileOut = CreateObject("java", "java.io.ByteArrayOutputStream").init()>
				<cfset out = CreateObject("java","java.util.zip.GZIPOutputStream").init(fileOut)>
				<cfset out.write(pageOut.getBytes(), 0, len(pageOut.getBytes()))>
				<cfset out.finish()>
				<cfset out.close()>
				<cfheader name="Content-Length" value="#fileOut.toString().length()#">
				<cfheader name="Content-Encoding" value="gzip">
				<cfcontent type="text/html" reset="true" variable="#fileOut.toByteArray()#">
			</cfif>
			<cfcatch type="Any"></cfcatch>
		</cftry>
		<cfreturn true />
	</cffunction>
	</cfsilent>
</cfcomponent>
