<cfsilent>
	<cfset path2logs = GetProfileString("#request.path2site#\cfWatcher.ini", "paths", "path2logs")>
	<cfparam name="logFile" default="">
	<cfparam name="logFileShort" default="">
	<cfparam name="id" default="0">
	<cffunction name="getByteArray" access="private" returnType="any" output="no">
		<cfargument name="size" type="numeric" required="true" />
		<cfscript>
			var emptyByteArray = createObject("java", "java.io.ByteArrayOutputStream").init().toByteArray();
			var byteClass = emptyByteArray.getClass().getComponentType();
			var byteArray = createObject("java","java.lang.reflect.Array").newInstance(byteClass, arguments.size);
			return byteArray;
		</cfscript>
	</cffunction>
	<cffunction name="unzip" access="public" returntype="string" output="no" hint="uncompresses a byte array and returns a string">
		<cfargument name="compByteArray" type="binary" required="yes" hint="a compressed byte array" />
		<cfscript>
			var decompresser = createObject("java","java.util.zip.Inflater").init();
			var bos = createObject("java","java.io.ByteArrayOutputStream").init(javaCast("int",len(arguments.compByteArray)));
			var buf = getByteArray(1024);
			var returnString = "";
			var count = 0;
			decompresser.setInput(arguments.compByteArray);
			while (not decompresser.finished())
			{
				count = decompresser.inflate(buf);
				bos.write(buf, 0, count);
			}
			decompresser.end();
			bos.close();
			returnString = createObject("java","java.lang.String").init(bos.toByteArray(),"UTF-8");
			return returnString.toString();
		</cfscript>
	</cffunction>
</cfsilent>

<cfoutput>
	<br>
	<cfflush interval="2">
	<cfif Len(logFile) gt 0 and Val(id) gt 0>
		<cfif FileExists("#path2logs#/#logFile#")>
			<cfscript>
				fileReader = CreateObject("java", "java.io.FileReader");
				fileReader.init("#path2logs#/#logFile#");
				br = CreateObject("java", "java.io.BufferedReader");
				br.init(fileReader);
				TotalNumRecords = 0;
			</cfscript>
			<cftry>
				<cfloop condition="true">
					<cfset line = br.readLine()>
					<cfset TotalNumRecords = TotalNumRecords + 1>
					<cfif TotalNumRecords eq id>
						#unzip(ToBinary(line))#
						<br>
						<cfbreak>
					</cfif>
				</cfloop>
				<cfcatch type="coldfusion.runtime.UndefinedVariableException">
					<!--- this indicates end of file, ok to ignore error --->
				</cfcatch>
			</cftry>
		<cfelse>
			No such log file.
		</cfif>
	</cfif>
</cfoutput>


